/*!
 *****************************************************************************
 * @file:
 * @brief:
 *-----------------------------------------------------------------------------
 *
Copyright (c) 2013-2018 Analog Devices, Inc. All Rights Reserved.

This software is proprietary to Analog Devices, Inc. and its licensors.
By using this software you agree to the terms of the associated
Analog Devices Software License Agreement.
 ******************************************************************************/

#include "ADuCM410.h"
#include "WdtLib.h"
#include "common.h"
#include "DioLib.h"
#include "ClkLib.h"




/*
   use one of follwoing to test different SRAM mode
   USER_SRAM_MODE macro in startup_ADuCM410.s and ADuCM410flash_SramMode.icf need to be changed accordingly 
*/
#define TEST_SRAM_MODE  0
//#define TEST_SRAM_MODE  1
//#define TEST_SRAM_MODE  2
//#define TEST_SRAM_MODE  3

#if TEST_SRAM_MODE==0 || TEST_SRAM_MODE==1
	#if defined (__ICCARM__)
		#pragma location ="ISRAM_REGION"
		void isramTestFunc()
	#else
__attribute__((section("ISRAM_REGION"))) void isramTestFunc(void);	//declaration
	void isramTestFunc() //this function will be placed in ISRAM
	#endif
{
   for(uint32_t i=0;i<30;i++)
   {
      LED_TOGGLE();
      for(uint32_t j=0;j<800000;j++);
   }
}
#define DATA_LENGTH	1*1024
#elif TEST_SRAM_MODE==3
//place data that requires 130K bytes SRAM space, which is only available in SRAM mode 3
#define DATA_LENGTH	130*1024

#elif TEST_SRAM_MODE==2
#define DATA_LENGTH	110*1024

#endif

extern uint8_t data[DATA_LENGTH];	//declaration
uint8_t data[DATA_LENGTH];

int main (void)
{
    WdtGo(false);
    ClkSetup(&gClkSetup);
	
    SystemInit();
    INIT();
    //SafetyWait();
	
    
#if TEST_SRAM_MODE==0 || TEST_SRAM_MODE==1
    isramTestFunc();
#endif
    for(uint32_t i=0;i<DATA_LENGTH;i++)
      data[i] = (uint8_t)i;
  
    
    while(1)
    {

    }
}











